sbit led at LATC0_bit;
sbit led1 at LATb7_bit;



//   lo que se va a capturar se toma desde PGGA  HASTA *
//estados de la recepcion de variables
enum estados_  {cap_P,cap_G,cap_G2,cap_A,esp_final} ;
//estado inicial
 char estado_rec=cap_P;    // VARIABLE DEL ESTADO ACTUAL
 
 
 //variables para capturar la trama
char trama_rx[100];
char procesa[100];
char dato_rx;  // DATO ACTUAL SWERIAL
char puntero_rx=0;  ///   recorrer el vector tramarx
char flag_rx=0; //  BANDERA DE TRAMA COMPLETA


float grados,minutos;
float latitud,longitud;
char texto[30];
char c_grados[10];   // grados en cadena

char flag_valido=0;



 void INTERRUPCION() iv 0x0008 ics ICS_AUTO

 {
     if (RCIF_bit==1)
     {
      dato_rx=UART1_Read();
       //maquina estados
      switch  (estado_rec)
      {
        case cap_P:
                     trama_rx[puntero_rx]=dato_rx;
                       if (dato_rx!='P') puntero_rx=0;    //no fue el dato que me interesa
                       else
                       {
                          puntero_rx++;//incrementa contador para proximo dato
                          estado_rec=cap_G; //pasa al estado de capturar la g
                       }
         case cap_G:
                       trama_rx[puntero_rx]=dato_rx;
                       if (dato_rx!='G')
                       {
                       puntero_rx=0;
                       estado_rec=cap_P; //regresa al estado inical
                       }
                       else
                       {
                          puntero_rx++;//incrementa contador para proximo dato
                         estado_rec=cap_G2; //pasa al estado de capturar la g
                       }
                     break;
                     
             case cap_G2:
                       trama_rx[puntero_rx]=dato_rx;
                       if (dato_rx!='G')
                       {
                       Puntero_rx=0;
                       estado_rec=cap_P; //regresa al estado inical
                       }
                       else
                       {
                          puntero_rx++;//incrementa contador para proximo dato
                          estado_rec=cap_A; //pasa al estado de capturar la a
                       }
                     break;
                     
               case cap_A:
                       trama_rx[puntero_rx]=dato_rx;
                       if (dato_rx!='A')
                       {
                       puntero_rx=0;
                       estado_rec=cap_P; //regresa al estado inical

                       }
                       else
                       {
                          puntero_rx++;//incrementa contador para proximo dato
                          estado_rec=esp_final; //pasa al estado de capturar la *
                       }

                     break;
                     
                  case esp_final:
                       trama_rx[puntero_rx]=dato_rx;
                       puntero_rx++;
                       if (dato_rx=='*')
                       {
                        RCIE_bit=0; ///   DESHABILITA INR
                        estado_rec=cap_P; //regresa al estado inical
                        puntero_rx=0;
                        flag_rx=1;  // bandera recepcion 1
                       }
                       break;

                     

                     





                  
                  break;
      
      
      
      }//fin switch
     
     
     RCIF_bit=0;
     }


 }
 
 

  void procesa_GPS()
{
 //captura la latitud
   strcpy(procesa, strtok(trama_rx, ","));  //inicia captura de tokens desde el

   strcpy(procesa, strtok(0, ","));  //captura hasta segunda coma
  strcpy(procesa, strtok(0, ","));  //captura hasta lo que esta tercera coma es decir, latitud
       memset(c_grados,0,10);//limpa los grados
       strncpy(c_grados,procesa,2);//captura los grados
         grados=atof(c_grados);      // pasa de alfanumerico o cadena a flotante

          // apunta a los minutos
         minutos=atof(&procesa[2])/60.0;  //lo pasa a grados
           latitud=grados+minutos;
           
       strcpy(procesa, strtok(0, ","));  //captura siguiente coma  //orientacion o signo de la lat
       if (procesa[0]=='S') latitud=-latitud;
   //ACONDICIONA PARA ENVIAR


  //  captura la longitud
       strcpy(procesa, strtok(0, ","));  //captura siguiente coma la longitud
     memset(c_grados,0,10);//limpa los grados
     
       strncpy(c_grados,procesa,3);//captura los grados  3 posiciones
          grados=atof(c_grados);
    // apunta a los minutos
         minutos=atof(&procesa[3])/60.0;  //lo pasa a grados
           longitud=grados+minutos;
       strcpy(procesa, strtok(0, ","));  //captura siguiente coma  //orientacion o signo de la long
       if (procesa[0]=='W') longitud=-longitud;

       strcpy(procesa, strtok(0, ","));  //captura siguiente coma  //orientacion o signo de la long
    
          if ( (procesa[0]=='1')|| (procesa[0]=='2') )
          {
            sprintf(texto,"lat=%f\r\n",latitud);
       UART1_Write_Text(texto);
          
            sprintf(texto,"lon=%f\r\n\r\n",longitud);
          UART1_Write_Text(texto);
          flag_valido=1;
          

          }
          else 
          {
          flag_valido=0;
          UART1_Write_Text("ESPERANDO GPS\r\n");
          }
          
       



}

void main() 
{
ADCON1=0b1111; // todo tigital
TRISC6_bit=0; // salida tx
TRISC7_bit=1; // entrada rx
TRISC0_bit=0; // salida led
TRISB7_bit=0;// salida led1

UART1_Init(9600);

INTCON=0B01000000; // MANDOS NMEDIOOS ACTIVO

RCIF_bit=0; // limpia la bandera serial
RCIE_bit=1; // habilita interrpcion serial
CREN_bit=1; // habilita la recepcion continua


GIE_bit=1;// pluma blanca



   while(1)
   {
       if (flag_rx==1)
       {
       // UART1_Write_Text(trama_rx);
       procesa_GPS();

        RCIF_bit=0;
        RCIE_bit=1;
       flag_rx=0;
       }
       
       if (flag_valido==1)
       {
       
        if ( (latitud>10.387127) && (latitud<10.387147) && (longitud>-75.500782) && (longitud<-75.500752))  led1=!led1; else led1=0;

       
       
       }
   
   
   //UART1_Write_Text("probando\r\n");
   Delay_ms(200);
   led=!led;
   
   }


}